<script setup>
import {useRoute} from "vue-router"
import {computed, ref, watch} from "vue"
import {useGroupStore} from "@/stores/group"
import Sidebar from "@/components/Sidebar.vue"
import {router} from "@/router";
import {useRoomStore} from "@/stores/room";
import {useEnumStore} from "@/stores/enumStore";

const route = useRoute()
const groupStore = useGroupStore()
const roomStore = useRoomStore()
const groupIndex = computed(() => parseInt(route.params.groupIndex))
const groupget = computed(() => groupStore.groups[groupIndex.value])

const edit = ref(false)
const specializations = ref("")
const groupNumber = ref("")
const startDate = ref("")
const endDate = ref("")
const roomId = ref()
const enumStore = useEnumStore()

const group = ref()

const apiError = ref("")

watch(groupget, () => group.value = ({...groupget.value} || {groupName: ""}), {immediate: true})

async function deleteGroup() {
  const response = await useGroupStore().deleteGroup(group.value);

  await router.push("/group")
  console.log("test");
}

async function updateGroup() {

  apiError.value = ""

  try {
    await groupStore.updateGroup({
      specializations: group.value.specializations,
      groupNumber: group.value.groupNumber,
      startDate: group.value.startDate,
      endDate: group.value.endDate,
      roomId: group.value.roomId

    })
    roomStore.rooms.find(room => group.value.roomId === room.roomId).groupId = group.value.groupId
  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }
  await router.push("/group")

  specializations.value = ""
  groupNumber.value = ""
  startDate.value = ""
  endDate.value = ""
  roomId.value = null
}

</script>

<template>
  <Sidebar></Sidebar>

  <h1>Details for Groups</h1>
  <div class="container text-white rounded-2 p-3 mb-3">
    <p>Name: <span v-if="!edit">{{ group.specializations }}</span>
      <select v-else class="form-select" v-model="group.specializations">
        <option v-for="specs in enumStore.specializations">{{ specs }}</option>
      </select></p>
    <p>Number: <span v-if="!edit">{{ group.groupNumber }}</span> <input v-else type="text" class="form-control"
                                                                        v-model="group.groupNumber"/></p>
    <p>Start Date: <span v-if="!edit">{{ group.startDate?.split('T')[0] }}</span> <input v-else class="form-control"
                                                                                         type="date"
                                                                                         v-model="group.startDate"/></p>
    <p>End Date: <span v-if="!edit">{{ group.endDate?.split('T')[0] }}</span> <input v-else class="form-control"
                                                                                     type="date"
                                                                                     v-model="group.endDate"/></p>
    <p>Room: <span v-if="!edit"> {{ roomStore.rooms.find(room => room.roomId === group.roomId)?.roomNumber }}
    {{ roomStore.rooms.find(room => room.roomId === group.roomId)?.roomName }}</span>
      <select v-else class="form-select" name="room" v-model="group.roomId">
        <option v-for="room in roomStore.rooms" :value="room.roomId">{{ room.roomNumber }} {{ room.vip }}</option>
      </select>
    </p>
  </div>
  <div class="buttons">
    <v-btn type="submit" class="btn btn-warning mx-2" @click="edit = !edit" v-if="!edit">Edit</v-btn>
    <v-btn type="submit" class="btn btn-warning mx-2" @click="updateGroup" v-else>Save</v-btn>
    <v-btn type="submit" class="btn btn-danger" @click="deleteGroup">Delete</v-btn>
  </div>

</template>

<style scoped>

h1 {
  margin-left: 0px;
  margin-bottom: 20px;
  margin-top: 0px;
}

p {
  margin-left: 0px;
}

.container {
  background-color: black;
  width: 1000px;
}

.buttons {
  margin-left: 0px;
  margin-top: 15px;
  margin-bottom: 20px;

}

</style>